<?php

Class Log
{
	protected static $file;
	protected static $result_file;

	public function __construct($file='log.txt', $result_file='result.txt')
	{
		self::$file = $file;
		self::$result_file = $result_file;
	}
	
	
	public static function AddLine($line)
	{
		$line = str_replace("\r\n", " ", $line);
		
		if (is_writable(self::$file))
		{
			if (!$handle = fopen(self::$file, 'a'))
			{
				//echo "    (" . $filename . ")";
				return(false);
			}
			
			if (flock($handle, LOCK_EX))
			{
				if (fwrite($handle, date("d.m.Y H:i:s") . " | " .  $line . "\r\n") === false)
				{
			        //echo "      (" . $filename . ")";
			        return(false);
			    }
				flock($handle, LOCK_UN);
			}
		   
		    fclose($handle);
		}
		return(true);
	}
	
	
	public static function RecordTarget($url, $target)
	{
		$line = $url . " | " . str_replace("\n", " ", str_replace("\r","", $target));
		
		if (is_writable(self::$result_file))
		{
			if (!$handle = fopen(self::$result_file, 'a'))
			{
				//echo "    (" . $filename . ")";
				return(false);
			}
			
			if (flock($handle, LOCK_EX))
			{
				if (fwrite($handle, date("d.m.Y H:i:s") . " | " .  $line . "\r\n") === false)
				{
			        //echo "      (" . $filename . ")";
			        return(false);
			    }
				flock($handle, LOCK_UN);
			}
		   
		    fclose($handle);
		}
		return(true);
	}
}

?>